/*
 * Copyright (c) 2004, 2005, ADAPT project partners (IST-2001-37126).
 * 
 * ManufacturerServiceImpl.java
 */

package org.eu.adapt.demonstrator.ws.manufacturer;

import java.net.URL;
import java.rmi.RemoteException;
import javax.xml.rpc.ServiceException;
import javax.xml.rpc.handler.MessageContext;
import javax.xml.rpc.server.ServiceLifecycle;
import javax.xml.rpc.server.ServletEndpointContext;
import org.ws_i.www.SampleApplications.SupplyChainManagement._2002_08.Configuration_xsd.*;
import org.ws_i.www.SampleApplications.SupplyChainManagement._2002_08.Configurator_wsdl.ConfiguratorFailedFault;
import org.ws_i.www.SampleApplications.SupplyChainManagement._2002_10.ManufacturerPO_xsd.*;
import org.ws_i.www.SampleApplications.SupplyChainManagement._2002_10.Manufacturer_wsdl.*;
import org.ws_i.www.SampleApplications.SupplyChainManagement._2002_10.Manufacturer.CallBack.*;
import org.eu.adapt.services.demo_1_0.PurchaseOrderBasicService_wsdl.PurchaseOrderBasicServiceLocator;
import org.eu.adapt.services.demo_1_0.PurchaseOrderBasicService_wsdl.PurchaseOrderBasicServicePortType;

public class ManufacturerServiceImpl implements ManufacturerPortType, ServiceLifecycle
{
    public ManufacturerServiceImpl()
    {
    }

    public void init(Object context)
        throws ServiceException
    {
        System.out.println("ManufacturerServiceImpl init");
        try
        {
            if (context != null)
            {
                MessageContext                    messageContext                     = ((ServletEndpointContext) context).getMessageContext();
                String                            purchaseOrderBasicServiceURLString = (String) messageContext.getProperty("PurchaseOrderBasicServiceURL");
                PurchaseOrderBasicServiceLocator  purchaseOrderBasicServiceLocator   = new PurchaseOrderBasicServiceLocator();

                _purchaseOrderBasicServicePortType = purchaseOrderBasicServiceLocator.getPurchaseOrder(new URL(purchaseOrderBasicServiceURLString));
                System.out.println("ManufacturerServiceImpl init 1: " + _purchaseOrderBasicServicePortType);
            }
            else
            {
                PurchaseOrderBasicServiceLocator  purchaseOrderBasicServiceLocator   = new PurchaseOrderBasicServiceLocator();

                _purchaseOrderBasicServicePortType = purchaseOrderBasicServiceLocator.getPurchaseOrder(new URL("http://stilton:8080/jboss-net/services/PurchaseOrderBasicService"));
                System.out.println("ManufacturerServiceImpl init 2: " + _purchaseOrderBasicServicePortType);
            }
        }
        catch (Exception exception)
        {
            throw new ServiceException("ManufacturerServiceImpl init failed", exception);
        }
        catch (Error error)
        {
            throw new ServiceException("ManufacturerServiceImpl init failed", error);
        }
    }

    public void destroy()
    {
        _purchaseOrderBasicServicePortType = null;
    }

    public boolean submitPO(PurchOrdType purchaseOrder, ConfigurationType configuration, StartHeaderType startHeader)
        throws RemoteException, ConfiguratorFailedFault, SubmitPOFaultType
    {
        boolean validPurchaseOrder = false;

        try
        {
            if (_purchaseOrderBasicServicePortType == null)
                init(null);
            
            validPurchaseOrder = _purchaseOrderBasicServicePortType.getCheckPurchaseOrder(purchaseOrder);
            
            if (validPurchaseOrder)
                _purchaseOrderBasicServicePortType.setAddPurchaseOrder(purchaseOrder);
        }
        catch (Exception exception)
        {
            System.err.print("Exception: " + exception);
            exception.printStackTrace(System.err);
            throw new RemoteException("ManufacturerServiceImpl submitPO failed", exception);
        }
        catch (Error error)
        {
            System.err.print("Error: " + error);
            error.printStackTrace(System.err);
            throw new RemoteException("ManufacturerServiceImpl submitPO failed", error);
        }
        
    	return validPurchaseOrder;
    }

    private PurchaseOrderBasicServicePortType _purchaseOrderBasicServicePortType = null;
}
